org.apache.poi.hssf.usermodel

## Class HSSFWorkbook

- java.lang.Object
- - org.apache.poi.POIDocument
  - - org.apache.poi.hssf.usermodel.HSSFWorkbook

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, java.lang.Iterable<Sheet>, Workbook

      public final class HSSFWorkbook
      extends POIDocument
      implements Workbook

  High level representation of a workbook. This is the first object most users will construct whether they are reading or writing a workbook. It is also the top level object for creating new sheets/etc.
  See Also:
    `InternalWorkbook`, `HSSFSheet`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.List<HSSFSheet>` | `_sheets` this holds the HSSFSheet objects attached to this workbook
    `static int` | `INITIAL_CAPACITY` used for compile-time performance/memory optimization.

    - ### Fields inherited from interface org.apache.poi.ss.usermodel.Workbook

      `PICTURE_TYPE_DIB, PICTURE_TYPE_EMF, PICTURE_TYPE_JPEG, PICTURE_TYPE_PICT, PICTURE_TYPE_PNG, PICTURE_TYPE_WMF`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HSSFWorkbook()` Creates new HSSFWorkbook from scratch (start here!)
    `HSSFWorkbook(DirectoryNode directory, boolean preserveNodes)` given a POI POIFSFileSystem object, and a specific directory within it, read in its Workbook and populate the high and low level models.
    `HSSFWorkbook(DirectoryNode directory, POIFSFileSystem fs, boolean preserveNodes)` given a POI POIFSFileSystem object, and a specific directory within it, read in its Workbook and populate the high and low level models.
    `HSSFWorkbook(java.io.InputStream s)` Companion to HSSFWorkbook(POIFSFileSystem), this constructs the POI filesystem around your `InputStream`, including all nodes.
    `HSSFWorkbook(java.io.InputStream s, boolean preserveNodes)` Companion to HSSFWorkbook(POIFSFileSystem), this constructs the POI filesystem around your `InputStream`.
    `HSSFWorkbook(POIFSFileSystem fs)` Given a POI POIFSFileSystem object, read in its Workbook along with all related nodes, and populate the high and low level models.
    `HSSFWorkbook(POIFSFileSystem fs, boolean preserveNodes)` Given a POI POIFSFileSystem object, read in its Workbook and populate the high and low level models.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `addOlePackage(byte[] oleData, java.lang.String label, java.lang.String fileName, java.lang.String command)` Adds an OLE package manager object with the given content to the sheet
    `int` | `addOlePackage(POIFSFileSystem poiData, java.lang.String label, java.lang.String fileName, java.lang.String command)` Adds an OLE package manager object with the given POIFS to the sheet
    `int` | `addPicture(byte[] pictureData, int format)` Adds a picture to the workbook.
    `void` | `addToolPack(UDFFinder toopack)` Register a new toolpack in this workbook.
    `boolean` | `changeExternalReference(java.lang.String oldUrl, java.lang.String newUrl)` Changes an external referenced file to another file.
    `HSSFSheet` | `cloneSheet(int sheetIndex)` create an HSSFSheet from an existing sheet in the HSSFWorkbook.
    `void` | `close()` Closes the underlying `POIFSFileSystem` from which the Workbook was read, if any.
    `static HSSFWorkbook` | `create(InternalWorkbook book)`
    `HSSFCellStyle` | `createCellStyle()` Create a new Cell style and add it to the workbook's style table.
    `HSSFDataFormat` | `createDataFormat()` Returns the instance of HSSFDataFormat for this workbook.
    `HSSFFont` | `createFont()` create a new Font and add it to the workbook's font table
    `HSSFName` | `createName()` creates a new named range and add it to the model
    `HSSFSheet` | `createSheet()` create an HSSFSheet for this HSSFWorkbook, adds it to the sheets and returns the high level representation.
    `HSSFSheet` | `createSheet(java.lang.String sheetname)` Create a new sheet for this Workbook and return the high level representation.
    `void` | `dumpDrawingGroupRecords(boolean fat)` Spits out a list of all the drawing records in the workbook.
    `HSSFFont` | `findFont(boolean bold, short color, short fontHeight, java.lang.String name, boolean italic, boolean strikeout, short typeOffset, byte underline)` Finds a font that matches the one with the supplied attributes
    `int` | `getActiveSheetIndex()` gets the tab whose data is actually seen when the sheet is opened.
    `java.util.List<HSSFObjectData>` | `getAllEmbeddedObjects()` Gets all embedded OLE2 objects from the Workbook.
    `java.util.List<HSSFName>` | `getAllNames()` Returns all defined names.
    `java.util.List<HSSFPictureData>` | `getAllPictures()` Gets all pictures from the Workbook.
    `boolean` | `getBackupFlag()` determine whether the Excel GUI will backup the workbook when saving.
    `byte[]` | `getBytes()` Method getBytes - get the bytes of just the HSSF portions of the XLS file.
    `HSSFCellStyle` | `getCellStyleAt(int idx)` get the cell style object at the given index
    `HSSFCreationHelper` | `getCreationHelper()` Returns an object that handles instantiating concrete classes of the various instances one needs for HSSF and XSSF.
    `HSSFPalette` | `getCustomPalette()`
    `EncryptionInfo` | `getEncryptionInfo()`
    `int` | `getFirstVisibleTab()` sets the first tab that is displayed in the list of tabs in excel.
    `HSSFFont` | `getFontAt(int idx)` Get the font at the given index number
    `HSSFFont` | `getFontAt(short idx)` Deprecated.
    `boolean` | `getForceFormulaRecalculation()` Whether Excel will be asked to recalculate all formulas when the workbook is opened.
    `InternalWorkbook` | `getInternalWorkbook()`
    `Row.MissingCellPolicy` | `getMissingCellPolicy()` Retrieves the current policy on what to do when getting missing or blank cells from a row.
    `HSSFName` | `getName(java.lang.String name)`
    `HSSFName` | `getNameAt(int nameIndex)`
    `int` | `getNameIndex(java.lang.String name)` Gets the defined name index by name Note: Excel defined names are case-insensitive and this method performs a case-insensitive search.
    `java.lang.String` | `getNameName(int index)` gets the named range name
    `NameRecord` | `getNameRecord(int nameIndex)`
    `java.util.List<HSSFName>` | `getNames(java.lang.String name)` Returns all defined names with the given name.
    `short` | `getNumberOfFonts()` Deprecated.
    `int` | `getNumberOfFontsAsInt()` Get the number of fonts in the font table
    `int` | `getNumberOfNames()`
    `int` | `getNumberOfSheets()` get the number of spreadsheets in the workbook (this will be three after serialization)
    `int` | `getNumCellStyles()` get the number of styles the workbook contains
    `java.lang.String` | `getPrintArea(int sheetIndex)` Retrieves the reference for the printarea of the specified sheet, the sheet name is appended to the reference even if it was not specified.
    `java.util.Collection<java.lang.Integer>` | `getSelectedTabs()` Gets the selected sheets (if more than one, Excel calls these a [Group]).
    `HSSFSheet` | `getSheet(java.lang.String name)` Get sheet with the given name (case insensitive match)
    `HSSFSheet` | `getSheetAt(int index)` Get the HSSFSheet object at the given index.
    `int` | `getSheetIndex(Sheet sheet)` Returns the index of the given sheet
    `int` | `getSheetIndex(java.lang.String name)` Returns the index of the sheet by his name
    `java.lang.String` | `getSheetName(int sheetIndex)` Get the sheet name
    `SheetVisibility` | `getSheetVisibility(int sheetIx)` Get the visibility (visible, hidden, very hidden) of a sheet in this workbook
    `SpreadsheetVersion` | `getSpreadsheetVersion()` Returns the spreadsheet version (EXCLE97) of this workbook
    `static java.lang.String` | `getWorkbookDirEntryName(DirectoryNode directory)`
    `void` | `insertChartRecord()` Test only.
    `boolean` | `isHidden()`
    `boolean` | `isSheetHidden(int sheetIx)` Check whether a sheet is hidden.
    `boolean` | `isSheetVeryHidden(int sheetIx)` Check whether a sheet is very hidden.
    `boolean` | `isWriteProtected()` Is the workbook protected with a password (not encrypted)?
    `java.util.Iterator<Sheet>` | `iterator()` Alias for `sheetIterator()` to allow foreach loops
    `int` | `linkExternalWorkbook(java.lang.String name, Workbook workbook)` Adds the LinkTable records required to allow formulas referencing the specified external workbook to be added to this one.
    `void` | `removeName(int index)` Remove the defined name at the specified index
    `void` | `removeName(Name name)` As `removeName(String)` is not necessarily unique (name + sheet index is unique), this method is more accurate.
    `void` | `removeName(java.lang.String name)` Remove a defined name by name
    `void` | `removePrintArea(int sheetIndex)` Delete the printarea for the sheet specified
    `void` | `removeSheetAt(int index)` Removes sheet at the given index.
    `void` | `setActiveSheet(int index)` Convenience method to set the active sheet.
    `void` | `setBackupFlag(boolean backupValue)` determine whether the Excel GUI will backup the workbook when saving.
    `void` | `setFirstVisibleTab(int index)` sets the first tab that is displayed in the list of tabs in excel.
    `void` | `setForceFormulaRecalculation(boolean value)` Whether the application shall perform a full recalculation when the workbook is opened.
    `void` | `setHidden(boolean hiddenFlag)`
    `void` | `setMissingCellPolicy(Row.MissingCellPolicy missingCellPolicy)` Sets the policy on what to do when getting missing or blank cells from a row.
    `void` | `setPrintArea(int sheetIndex, int startColumn, int endColumn, int startRow, int endRow)` For the Convenience of Java Programmers maintaining pointers.
    `void` | `setPrintArea(int sheetIndex, java.lang.String reference)` Sets the printarea for the sheet provided
    `void` | `setSelectedTab(int index)` Selects a single sheet.
    `void` | `setSelectedTabs(java.util.Collection<java.lang.Integer> indexes)` Selects multiple sheets as a group.
    `void` | `setSelectedTabs(int[] indexes)` Selects multiple sheets as a group.
    `void` | `setSheetHidden(int sheetIx, boolean hidden)` Hide or unhide a sheet.
    `void` | `setSheetName(int sheetIx, java.lang.String name)` Set the sheet name.
    `void` | `setSheetOrder(java.lang.String sheetname, int pos)` sets the order of appearance for a given sheet.
    `void` | `setSheetVisibility(int sheetIx, SheetVisibility visibility)` Hide or unhide a sheet.
    `java.util.Iterator<Sheet>` | `sheetIterator()` Returns an iterator of the sheets in the workbook in sheet order.
    `void` | `unwriteProtectWorkbook()` removes the write protect flag
    `void` | `write()` Write out this workbook to the currently open `File` via the writeable `POIFSFileSystem` it was opened as.
    `void` | `write(java.io.File newFile)` Method write - write out this workbook to a new `File`.
    `void` | `write(java.io.OutputStream stream)` Method write - write out this workbook to an `OutputStream`.
    `void` | `writeProtectWorkbook(java.lang.String password, java.lang.String username)` protect a workbook with a password (not encypted, just sets writeprotect flags and the password.

    - ### Methods inherited from class org.apache.poi.POIDocument

      `clearDirectory, createInformationProperties, getDirectory, getDocumentSummaryInformation, getEncryptedPropertyStreamName, getPropertySet, getPropertySet, getSummaryInformation, initDirectory, readProperties, replaceDirectory, validateInPlaceWritePossible, writeProperties, writeProperties, writeProperties`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Field Detail

    - #### INITIAL_CAPACITY

          public static final int INITIAL_CAPACITY

      used for compile-time performance/memory optimization. This determines the initial capacity for the sheet collection. Its currently set to 3. Changing it in this release will decrease performance since you're never allowed to have more or less than three sheets!

    - #### _sheets

          protected java.util.List<HSSFSheet> _sheets

      this holds the HSSFSheet objects attached to this workbook

  - ### Constructor Detail

    - #### HSSFWorkbook

          public HSSFWorkbook()

      Creates new HSSFWorkbook from scratch (start here!)

    - #### HSSFWorkbook

          public HSSFWorkbook(POIFSFileSystem fs)
                       throws java.io.IOException

      Given a POI POIFSFileSystem object, read in its Workbook along with all related nodes, and populate the high and low level models.

      This calls `HSSFWorkbook(POIFSFileSystem, boolean)` with preserve nodes set to true.

      Throws:
        `java.io.IOException` - if the stream cannot be read
      See Also:
        `HSSFWorkbook(POIFSFileSystem, boolean)`, `POIFSFileSystem`

    - #### HSSFWorkbook

          public HSSFWorkbook(POIFSFileSystem fs,
                              boolean preserveNodes)
                       throws java.io.IOException

      Given a POI POIFSFileSystem object, read in its Workbook and populate the high and low level models. If you're reading in a workbook... start here!
      Parameters:
        `fs` - the POI filesystem that contains the Workbook stream.
        `preserveNodes` - whether to preserve other nodes, such as macros. This takes more memory, so only say yes if you need to. If set, will store all of the POIFSFileSystem in memory
      Throws:
        `java.io.IOException` - if the stream cannot be read
      See Also:
        `POIFSFileSystem`

    - #### HSSFWorkbook

          public HSSFWorkbook(DirectoryNode directory,
                              POIFSFileSystem fs,
                              boolean preserveNodes)
                       throws java.io.IOException

      given a POI POIFSFileSystem object, and a specific directory within it, read in its Workbook and populate the high and low level models. If you're reading in a workbook...start here.
      Parameters:
        `directory` - the POI filesystem directory to process from
        `fs` - the POI filesystem that contains the Workbook stream.
        `preserveNodes` - whether to preserve other nodes, such as macros. This takes more memory, so only say yes if you need to. If set, will store all of the POIFSFileSystem in memory
      Throws:
        `java.io.IOException` - if the stream cannot be read
      See Also:
        `POIFSFileSystem`

    - #### HSSFWorkbook

          public HSSFWorkbook(DirectoryNode directory,
                              boolean preserveNodes)
                       throws java.io.IOException

      given a POI POIFSFileSystem object, and a specific directory within it, read in its Workbook and populate the high and low level models. If you're reading in a workbook...start here.
      Parameters:
        `directory` - the POI filesystem directory to process from
        `preserveNodes` - whether to preserve other nodes, such as macros. This takes more memory, so only say yes if you need to. If set, will store all of the POIFSFileSystem in memory
      Throws:
        `java.io.IOException` - if the stream cannot be read
      See Also:
        `POIFSFileSystem`

    - #### HSSFWorkbook

          public HSSFWorkbook(java.io.InputStream s)
                       throws java.io.IOException

      Companion to HSSFWorkbook(POIFSFileSystem), this constructs the POI filesystem around your `InputStream`, including all nodes.

      This calls `HSSFWorkbook(InputStream, boolean)` with preserve nodes set to true.

      Throws:
        `java.io.IOException` - if the stream cannot be read
      See Also:
        `HSSFWorkbook(InputStream, boolean)`, `HSSFWorkbook(POIFSFileSystem)`, `POIFSFileSystem`

    - #### HSSFWorkbook

          public HSSFWorkbook(java.io.InputStream s,
                              boolean preserveNodes)
                       throws java.io.IOException

      Companion to HSSFWorkbook(POIFSFileSystem), this constructs the POI filesystem around your `InputStream`.
      Parameters:
        `s` - the POI filesystem that contains the Workbook stream.
        `preserveNodes` - whether to preserve other nodes, such as macros. This takes more memory, so only say yes if you need to.
      Throws:
        `java.io.IOException` - if the stream cannot be read
      See Also:
        `POIFSFileSystem`, `HSSFWorkbook(POIFSFileSystem)`

  - ### Method Detail

    - #### create

          public static HSSFWorkbook create(InternalWorkbook book)

    - #### getWorkbookDirEntryName

          public static java.lang.String getWorkbookDirEntryName(DirectoryNode directory)

    - #### getMissingCellPolicy

          public Row.MissingCellPolicy getMissingCellPolicy()

      Retrieves the current policy on what to do when getting missing or blank cells from a row. The default is to return blank and null cells. `Row.MissingCellPolicy`
      Specified by:
        `getMissingCellPolicy` in interface `Workbook`

    - #### setMissingCellPolicy

          public void setMissingCellPolicy(Row.MissingCellPolicy missingCellPolicy)

      Sets the policy on what to do when getting missing or blank cells from a row. This will then apply to all calls to `HSSFRow.getCell(int)`}. See `Row.MissingCellPolicy`. Note that this has no effect on any iterators, only on when fetching Cells by their column index.
      Specified by:
        `setMissingCellPolicy` in interface `Workbook`

    - #### setSheetOrder

          public void setSheetOrder(java.lang.String sheetname,
                                    int pos)

      sets the order of appearance for a given sheet.
      Specified by:
        `setSheetOrder` in interface `Workbook`
      Parameters:
        `sheetname` - the name of the sheet to reorder
        `pos` - the position that we want to insert the sheet into (0 based)

    - #### setSelectedTab

          public void setSelectedTab(int index)

      Selects a single sheet. This may be different to the 'active' sheet (which is the sheet with focus).
      Specified by:
        `setSelectedTab` in interface `Workbook`
      Parameters:
        `index` - the index of the sheet to select (0 based)
      See Also:
        `Sheet.setSelected(boolean)`

    - #### setSelectedTabs

          public void setSelectedTabs(int[] indexes)

      Selects multiple sheets as a group. This is distinct from the 'active' sheet (which is the sheet with focus). Unselects sheets that are not in `indexes`.
      Parameters:
        `indexes` - Array of sheets to select, the index is 0-based.

    - #### setSelectedTabs

          public void setSelectedTabs(java.util.Collection<java.lang.Integer> indexes)

      Selects multiple sheets as a group. This is distinct from the 'active' sheet (which is the sheet with focus). Unselects sheets that are not in `indexes`.
      Parameters:
        `indexes` - Collection of sheets to select, the index is 0-based.

    - #### getSelectedTabs

          public java.util.Collection<java.lang.Integer> getSelectedTabs()

      Gets the selected sheets (if more than one, Excel calls these a [Group]).
      Returns:
        indices of selected sheets

    - #### setActiveSheet

          public void setActiveSheet(int index)

      Convenience method to set the active sheet. The active sheet is is the sheet which is currently displayed when the workbook is viewed in Excel. 'Selected' sheet(s) is a distinct concept.
      Specified by:
        `setActiveSheet` in interface `Workbook`
      Parameters:
        `index` - index of the active sheet (0-based)

    - #### getActiveSheetIndex

          public int getActiveSheetIndex()

      gets the tab whose data is actually seen when the sheet is opened. This may be different from the "selected sheet" since excel seems to allow you to show the data of one sheet when another is seen "selected" in the tabs (at the bottom).
      Specified by:
        `getActiveSheetIndex` in interface `Workbook`
      Returns:
        the index of the active sheet (0-based)
      See Also:
        `HSSFSheet.setSelected(boolean)`

    - #### setFirstVisibleTab

          public void setFirstVisibleTab(int index)

      sets the first tab that is displayed in the list of tabs in excel. This method does not hide, select or focus sheets. It just sets the scroll position in the tab-bar.
      Specified by:
        `setFirstVisibleTab` in interface `Workbook`
      Parameters:
        `index` - the sheet index of the tab that will become the first in the tab-bar

    - #### getFirstVisibleTab

          public int getFirstVisibleTab()

      sets the first tab that is displayed in the list of tabs in excel.
      Specified by:
        `getFirstVisibleTab` in interface `Workbook`
      Returns:
        the first tab that to display in the list of tabs (0-based).

    - #### setSheetName

          public void setSheetName(int sheetIx,
                                   java.lang.String name)

      Set the sheet name.
      Specified by:
        `setSheetName` in interface `Workbook`
      Parameters:
        `sheetIx` - number (0 based)
      Throws:
        `java.lang.IllegalArgumentException` - if the name is null or invalid or workbook already contains a sheet with this name
      See Also:
        `createSheet(String)`, `WorkbookUtil.createSafeSheetName(String nameProposal)`

    - #### getSheetName

          public java.lang.String getSheetName(int sheetIndex)

      Description copied from interface: `Workbook`
      Get the sheet name
      Specified by:
        `getSheetName` in interface `Workbook`
      Parameters:
        `sheetIndex` - sheet number (0 based)
      Returns:
        Sheet name for the specified index

    - #### isHidden

          public boolean isHidden()

      Specified by:
        `isHidden` in interface `Workbook`
      Returns:
        `false` if this workbook is not visible in the GUI

    - #### setHidden

          public void setHidden(boolean hiddenFlag)

      Specified by:
        `setHidden` in interface `Workbook`
      Parameters:
        `hiddenFlag` - pass `false` to make the workbook visible in the GUI

    - #### isSheetHidden

          public boolean isSheetHidden(int sheetIx)

      Description copied from interface: `Workbook`
      Check whether a sheet is hidden.

      Note that a sheet could instead be set to be very hidden, which is different (`Workbook.isSheetVeryHidden(int)`)

      Specified by:
        `isSheetHidden` in interface `Workbook`
      Parameters:
        `sheetIx` - Number
      Returns:
        `true` if sheet is hidden
      See Also:
        `Workbook.getSheetVisibility(int)`

    - #### isSheetVeryHidden

          public boolean isSheetVeryHidden(int sheetIx)

      Description copied from interface: `Workbook`
      Check whether a sheet is very hidden.

      This is different from the normal hidden status (`Workbook.isSheetHidden(int)`)

      Specified by:
        `isSheetVeryHidden` in interface `Workbook`
      Parameters:
        `sheetIx` - sheet index to check
      Returns:
        `true` if sheet is very hidden
      See Also:
        `Workbook.getSheetVisibility(int)`

    - #### getSheetVisibility

          public SheetVisibility getSheetVisibility(int sheetIx)

      Description copied from interface: `Workbook`
      Get the visibility (visible, hidden, very hidden) of a sheet in this workbook
      Specified by:
        `getSheetVisibility` in interface `Workbook`
      Parameters:
        `sheetIx` - the index of the sheet
      Returns:
        the sheet visibility

    - #### setSheetHidden

          public void setSheetHidden(int sheetIx,
                                     boolean hidden)

      Description copied from interface: `Workbook`
      Hide or unhide a sheet. Please note that the sheet currently set as active sheet (sheet 0 in a newly created workbook or the one set via setActiveSheet()) cannot be hidden.
      Specified by:
        `setSheetHidden` in interface `Workbook`
      Parameters:
        `sheetIx` - the sheet index (0-based)
        `hidden` - True to mark the sheet as hidden, false otherwise
      See Also:
        `Workbook.setSheetVisibility(int, SheetVisibility)`

    - #### setSheetVisibility

          public void setSheetVisibility(int sheetIx,
                                         SheetVisibility visibility)

      Description copied from interface: `Workbook`
      Hide or unhide a sheet. Please note that the sheet currently set as active sheet (sheet 0 in a newly created workbook or the one set via setActiveSheet()) cannot be hidden.
      Specified by:
        `setSheetVisibility` in interface `Workbook`
      Parameters:
        `sheetIx` - the sheet index (0-based)
        `visibility` - the sheet visibility to set

    - #### getSheetIndex

          public int getSheetIndex(java.lang.String name)

      Returns the index of the sheet by his name
      Specified by:
        `getSheetIndex` in interface `Workbook`
      Parameters:
        `name` - the sheet name
      Returns:
        index of the sheet (0 based)

    - #### getSheetIndex

          public int getSheetIndex(Sheet sheet)

      Returns the index of the given sheet
      Specified by:
        `getSheetIndex` in interface `Workbook`
      Parameters:
        `sheet` - the sheet to look up
      Returns:
        index of the sheet (0 based). `-1` if not found

    - #### createSheet

          public HSSFSheet createSheet()

      create an HSSFSheet for this HSSFWorkbook, adds it to the sheets and returns the high level representation. Use this to create new sheets.
      Specified by:
        `createSheet` in interface `Workbook`
      Returns:
        HSSFSheet representing the new sheet.

    - #### cloneSheet

          public HSSFSheet cloneSheet(int sheetIndex)

      create an HSSFSheet from an existing sheet in the HSSFWorkbook.
      Specified by:
        `cloneSheet` in interface `Workbook`
      Returns:
        HSSFSheet representing the cloned sheet.

    - #### createSheet

          public HSSFSheet createSheet(java.lang.String sheetname)

      Create a new sheet for this Workbook and return the high level representation. Use this to create new sheets.

      Note that Excel allows sheet names up to 31 chars in length but other applications (such as OpenOffice) allow more. Some versions of Excel crash with names longer than 31 chars, others - truncate such names to 31 character.

      POI's SpreadsheetAPI silently truncates the input argument to 31 characters. Example:

               Sheet sheet = workbook.createSheet("My very long sheet name which is longer than 31 chars"); // will be truncated
               assert 31 == sheet.getSheetName().length();
               assert "My very long sheet name which i" == sheet.getSheetName();

      Except the 31-character constraint, Excel applies some other rules:

      Sheet name MUST be unique in the workbook and MUST NOT contain the any of the following characters:

      - 0x0000
      - 0x0003
      - colon (:)
      - backslash (\)
      - asterisk (*)
      - question mark (?)
      - forward slash (/)
      - opening square bracket ([)
      - closing square bracket (])
      The string MUST NOT begin or end with the single quote (') character.
      Specified by:
        `createSheet` in interface `Workbook`
      Parameters:
        `sheetname` - sheetname to set for the sheet.
      Returns:
        Sheet representing the new sheet.
      Throws:
        `java.lang.IllegalArgumentException` - if the name is null or invalid or workbook already contains a sheet with this name
      See Also:
        `WorkbookUtil.createSafeSheetName(String nameProposal)`

    - #### sheetIterator

          public java.util.Iterator<Sheet> sheetIterator()

      Returns an iterator of the sheets in the workbook in sheet order. Includes hidden and very hidden sheets.
      Specified by:
        `sheetIterator` in interface `Workbook`
      Returns:
        an iterator of the sheets.

    - #### iterator

          public java.util.Iterator<Sheet> iterator()

      Alias for `sheetIterator()` to allow foreach loops
      Specified by:
        `iterator` in interface `java.lang.Iterable<Sheet>`

    - #### getNumberOfSheets

          public int getNumberOfSheets()

      get the number of spreadsheets in the workbook (this will be three after serialization)
      Specified by:
        `getNumberOfSheets` in interface `Workbook`
      Returns:
        number of sheets

    - #### getSheetAt

          public HSSFSheet getSheetAt(int index)

      Get the HSSFSheet object at the given index.
      Specified by:
        `getSheetAt` in interface `Workbook`
      Parameters:
        `index` - of the sheet number (0-based physical & logical)
      Returns:
        HSSFSheet at the provided index
      Throws:
        `java.lang.IllegalArgumentException` - if the index is out of range (index < 0 || index >= getNumberOfSheets()).

    - #### getSheet

          public HSSFSheet getSheet(java.lang.String name)

      Get sheet with the given name (case insensitive match)
      Specified by:
        `getSheet` in interface `Workbook`
      Parameters:
        `name` - of the sheet
      Returns:
        HSSFSheet with the name provided or `null` if it does not exist

    - #### removeSheetAt

          public void removeSheetAt(int index)

      Removes sheet at the given index.

      Care must be taken if the removed sheet is the currently active or only selected sheet in the workbook. There are a few situations when Excel must have a selection and/or active sheet. (For example when printing - see Bug 40414).
      This method makes sure that if the removed sheet was active, another sheet will become active in its place. Furthermore, if the removed sheet was the only selected sheet, another sheet will become selected. The newly active/selected sheet will have the same index, or one less if the removed sheet was the last in the workbook.

      Specified by:
        `removeSheetAt` in interface `Workbook`
      Parameters:
        `index` - of the sheet (0-based)

    - #### setBackupFlag

          public void setBackupFlag(boolean backupValue)

      determine whether the Excel GUI will backup the workbook when saving.
      Parameters:
        `backupValue` - true to indicate a backup will be performed.

    - #### getBackupFlag

          public boolean getBackupFlag()

      determine whether the Excel GUI will backup the workbook when saving.
      Returns:
        the current setting for backups.

    - #### createFont

          public HSSFFont createFont()

      create a new Font and add it to the workbook's font table
      Specified by:
        `createFont` in interface `Workbook`
      Returns:
        new font object

    - #### findFont

          public HSSFFont findFont(boolean bold,
                                   short color,
                                   short fontHeight,
                                   java.lang.String name,
                                   boolean italic,
                                   boolean strikeout,
                                   short typeOffset,
                                   byte underline)

      Finds a font that matches the one with the supplied attributes
      Specified by:
        `findFont` in interface `Workbook`
      Returns:
        the font with the matched attributes or `null`

    - #### getNumberOfFonts

          @Deprecated
          public short getNumberOfFonts()

      Deprecated.
      Description copied from interface: `Workbook`
      Get the number of fonts in the font table
      Specified by:
        `getNumberOfFonts` in interface `Workbook`
      Returns:
        number of fonts

    - #### getNumberOfFontsAsInt

          public int getNumberOfFontsAsInt()

      Description copied from interface: `Workbook`
      Get the number of fonts in the font table
      Specified by:
        `getNumberOfFontsAsInt` in interface `Workbook`
      Returns:
        number of fonts

    - #### getFontAt

          @Deprecated
          public HSSFFont getFontAt(short idx)

      Deprecated.
      Description copied from interface: `Workbook`
      Get the font at the given index number
      Specified by:
        `getFontAt` in interface `Workbook`
      Parameters:
        `idx` - index number (0-based)
      Returns:
        font at the index

    - #### getFontAt

          public HSSFFont getFontAt(int idx)

      Description copied from interface: `Workbook`
      Get the font at the given index number
      Specified by:
        `getFontAt` in interface `Workbook`
      Parameters:
        `idx` - index number (0-based)
      Returns:
        font at the index

    - #### createCellStyle

          public HSSFCellStyle createCellStyle()

      Create a new Cell style and add it to the workbook's style table. You can define up to 4000 unique styles in a .xls workbook.
      Specified by:
        `createCellStyle` in interface `Workbook`
      Returns:
        the new Cell Style object
      Throws:
        `java.lang.IllegalStateException` - if the number of cell styles exceeded the limit for this type of Workbook.

    - #### getNumCellStyles

          public int getNumCellStyles()

      get the number of styles the workbook contains
      Specified by:
        `getNumCellStyles` in interface `Workbook`
      Returns:
        count of cell styles

    - #### getCellStyleAt

          public HSSFCellStyle getCellStyleAt(int idx)

      get the cell style object at the given index
      Specified by:
        `getCellStyleAt` in interface `Workbook`
      Parameters:
        `idx` - index within the set of styles
      Returns:
        HSSFCellStyle object at the index

    - #### close

          public void close()
                     throws java.io.IOException

      Closes the underlying `POIFSFileSystem` from which the Workbook was read, if any.

      Once this has been called, no further operations, updates or reads should be performed on the Workbook.

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `Workbook`
      Overrides:
        `close` in class `POIDocument`
      Throws:
        `java.io.IOException`

    - #### write

          public void write()
                     throws java.io.IOException

      Write out this workbook to the currently open `File` via the writeable `POIFSFileSystem` it was opened as.

      This will fail (with an `IllegalStateException` if the Workbook was opened read-only, opened from an `InputStream` instead of a File, or if this is not the root document. For those cases, you must use `write(OutputStream)` or `write(File)` to write to a brand new document.

      Specified by:
        `write` in class `POIDocument`
      Throws:
        `java.io.IOException` - thrown on errors writing to the file

    - #### write

          public void write(java.io.File newFile)
                     throws java.io.IOException

      Method write - write out this workbook to a new `File`. Constructs a new POI POIFSFileSystem, passes in the workbook binary representation and writes it out. If the file exists, it will be replaced, otherwise a new one will be created. Note that you cannot write to the currently open File using this method. If you opened your Workbook from a File, you must use the `write()` method instead!
      Specified by:
        `write` in class `POIDocument`
      Parameters:
        `newFile` - The new File you wish to write the XLS to
      Throws:
        `java.io.IOException` - if anything can't be written.
      See Also:
        `POIFSFileSystem`

    - #### write

          public void write(java.io.OutputStream stream)
                     throws java.io.IOException

      Method write - write out this workbook to an `OutputStream`. Constructs a new POI POIFSFileSystem, passes in the workbook binary representation and writes it out. If `stream` is a `FileOutputStream` on a networked drive or has a high cost/latency associated with each written byte, consider wrapping the OutputStream in a `BufferedOutputStream` to improve write performance.
      Specified by:
        `write` in interface `Workbook`
      Specified by:
        `write` in class `POIDocument`
      Parameters:
        `stream` - - the java OutputStream you wish to write the XLS to
      Throws:
        `java.io.IOException` - if anything can't be written.
      See Also:
        `POIFSFileSystem`

    - #### getBytes

          public byte[] getBytes()

      Method getBytes - get the bytes of just the HSSF portions of the XLS file. Use this to construct a POI POIFSFileSystem yourself.
      Returns:
        byte[] array containing the binary representation of this workbook and all contained sheets, rows, cells, etc.

    - #### getNumberOfNames

          public int getNumberOfNames()

      Specified by:
        `getNumberOfNames` in interface `Workbook`
      Returns:
        the total number of defined names in this workbook

    - #### getName

          public HSSFName getName(java.lang.String name)

      Specified by:
        `getName` in interface `Workbook`
      Parameters:
        `name` - the name of the defined name
      Returns:
        the defined name with the specified name. `null` if not found.

    - #### getNames

          public java.util.List<HSSFName> getNames(java.lang.String name)

      Description copied from interface: `Workbook`
      Returns all defined names with the given name.
      Specified by:
        `getNames` in interface `Workbook`
      Parameters:
        `name` - the name of the defined name
      Returns:
        a list of the defined names with the specified name. An empty list is returned if none is found.

    - #### getNameAt

          public HSSFName getNameAt(int nameIndex)

      Specified by:
        `getNameAt` in interface `Workbook`
      Parameters:
        `nameIndex` - position of the named range (0-based)
      Returns:
        the defined name at the specified index

    - #### getAllNames

          public java.util.List<HSSFName> getAllNames()

      Description copied from interface: `Workbook`
      Returns all defined names.
      Specified by:
        `getAllNames` in interface `Workbook`
      Returns:
        a list of the defined names. An empty list is returned if none is found.

    - #### getNameRecord

          public NameRecord getNameRecord(int nameIndex)

    - #### getNameName

          public java.lang.String getNameName(int index)

      gets the named range name
      Parameters:
        `index` - the named range index (0 based)
      Returns:
        named range name

    - #### setPrintArea

          public void setPrintArea(int sheetIndex,
                                   java.lang.String reference)

      Sets the printarea for the sheet provided

      i.e. Reference = $A$1:$B$2

      Specified by:
        `setPrintArea` in interface `Workbook`
      Parameters:
        `sheetIndex` - Zero-based sheet index (0 Represents the first sheet to keep consistent with java)
        `reference` - Valid name Reference for the Print Area

    - #### setPrintArea

          public void setPrintArea(int sheetIndex,
                                   int startColumn,
                                   int endColumn,
                                   int startRow,
                                   int endRow)

      For the Convenience of Java Programmers maintaining pointers.
      Specified by:
        `setPrintArea` in interface `Workbook`
      Parameters:
        `sheetIndex` - Zero-based sheet index (0 = First Sheet)
        `startColumn` - Column to begin printarea
        `endColumn` - Column to end the printarea
        `startRow` - Row to begin the printarea
        `endRow` - Row to end the printarea
      See Also:
        `setPrintArea(int, String)`

    - #### getPrintArea

          public java.lang.String getPrintArea(int sheetIndex)

      Retrieves the reference for the printarea of the specified sheet, the sheet name is appended to the reference even if it was not specified.
      Specified by:
        `getPrintArea` in interface `Workbook`
      Parameters:
        `sheetIndex` - Zero-based sheet index (0 Represents the first sheet to keep consistent with java)
      Returns:
        String Null if no print area has been defined

    - #### removePrintArea

          public void removePrintArea(int sheetIndex)

      Delete the printarea for the sheet specified
      Specified by:
        `removePrintArea` in interface `Workbook`
      Parameters:
        `sheetIndex` - Zero-based sheet index (0 = First Sheet)

    - #### createName

          public HSSFName createName()

      creates a new named range and add it to the model
      Specified by:
        `createName` in interface `Workbook`
      Returns:
        named range high level

    - #### getNameIndex

          public int getNameIndex(java.lang.String name)

      Description copied from interface: `Workbook`
      Gets the defined name index by name
      Note: Excel defined names are case-insensitive and this method performs a case-insensitive search.
      Specified by:
        `getNameIndex` in interface `Workbook`
      Parameters:
        `name` - the name of the defined name
      Returns:
        zero based index of the defined name. `-1` if not found.

    - #### removeName

          public void removeName(int index)

      Description copied from interface: `Workbook`
      Remove the defined name at the specified index
      Specified by:
        `removeName` in interface `Workbook`
      Parameters:
        `index` - named range index (0 based)

    - #### createDataFormat

          public HSSFDataFormat createDataFormat()

      Returns the instance of HSSFDataFormat for this workbook.
      Specified by:
        `createDataFormat` in interface `Workbook`
      Returns:
        the HSSFDataFormat object
      See Also:
        `FormatRecord`, `Record`

    - #### removeName

          public void removeName(java.lang.String name)

      Description copied from interface: `Workbook`
      Remove a defined name by name
      Specified by:
        `removeName` in interface `Workbook`
      Parameters:
        `name` - the name of the defined name

    - #### removeName

          public void removeName(Name name)

      As `removeName(String)` is not necessarily unique (name + sheet index is unique), this method is more accurate.
      Specified by:
        `removeName` in interface `Workbook`
      Parameters:
        `name` - the name to remove.

    - #### getCustomPalette

          public HSSFPalette getCustomPalette()

    - #### insertChartRecord

          public void insertChartRecord()

      Test only. Do not use

    - #### dumpDrawingGroupRecords

          public void dumpDrawingGroupRecords(boolean fat)

      Spits out a list of all the drawing records in the workbook.

    - #### addPicture

          public int addPicture(byte[] pictureData,
                                int format)

      Adds a picture to the workbook.
      Specified by:
        `addPicture` in interface `Workbook`
      Parameters:
        `pictureData` - The bytes of the picture
        `format` - The format of the picture. One of `PICTURE_TYPE_*`
      Returns:
        the index to this picture (1 based).
      See Also:
        `Workbook.PICTURE_TYPE_WMF`, `Workbook.PICTURE_TYPE_EMF`, `Workbook.PICTURE_TYPE_PICT`, `Workbook.PICTURE_TYPE_PNG`, `Workbook.PICTURE_TYPE_JPEG`, `Workbook.PICTURE_TYPE_DIB`

    - #### getAllPictures

          public java.util.List<HSSFPictureData> getAllPictures()

      Gets all pictures from the Workbook.
      Specified by:
        `getAllPictures` in interface `Workbook`
      Returns:
        the list of pictures (a list of `HSSFPictureData` objects.)

    - #### addOlePackage

          public int addOlePackage(POIFSFileSystem poiData,
                                   java.lang.String label,
                                   java.lang.String fileName,
                                   java.lang.String command)
                            throws java.io.IOException

      Adds an OLE package manager object with the given POIFS to the sheet
      Parameters:
        `poiData` - an POIFS containing the embedded document, to be added
        `label` - the label of the payload
        `fileName` - the original filename
        `command` - the command to open the payload
      Returns:
        the index of the added ole object
      Throws:
        `java.io.IOException` - if the object can't be embedded

    - #### addOlePackage

          public int addOlePackage(byte[] oleData,
                                   java.lang.String label,
                                   java.lang.String fileName,
                                   java.lang.String command)
                            throws java.io.IOException

      Description copied from interface: `Workbook`
      Adds an OLE package manager object with the given content to the sheet
      Specified by:
        `addOlePackage` in interface `Workbook`
      Parameters:
        `oleData` - the payload
        `label` - the label of the payload
        `fileName` - the original filename
        `command` - the command to open the payload
      Returns:
        the index of the added ole object, i.e. the storage id
      Throws:
        `java.io.IOException` - if the object can't be embedded

    - #### linkExternalWorkbook

          public int linkExternalWorkbook(java.lang.String name,
                                          Workbook workbook)

      Adds the LinkTable records required to allow formulas referencing the specified external workbook to be added to this one. Allows formulas such as "[MyOtherWorkbook]Sheet3!$A$5" to be added to the file, for workbooks not already referenced.
      Specified by:
        `linkExternalWorkbook` in interface `Workbook`
      Parameters:
        `name` - The name the workbook will be referenced as in formulas
        `workbook` - The open workbook to fetch the link required information from

    - #### isWriteProtected

          public boolean isWriteProtected()

      Is the workbook protected with a password (not encrypted)?

    - #### writeProtectWorkbook

          public void writeProtectWorkbook(java.lang.String password,
                                           java.lang.String username)

      protect a workbook with a password (not encypted, just sets writeprotect flags and the password.
      Parameters:
        `password` - to set

    - #### unwriteProtectWorkbook

          public void unwriteProtectWorkbook()

      removes the write protect flag

    - #### getAllEmbeddedObjects

          public java.util.List<HSSFObjectData> getAllEmbeddedObjects()

      Gets all embedded OLE2 objects from the Workbook.
      Returns:
        the list of embedded objects (a list of `HSSFObjectData` objects.)

    - #### getCreationHelper

          public HSSFCreationHelper getCreationHelper()

      Description copied from interface: `Workbook`
      Returns an object that handles instantiating concrete classes of the various instances one needs for HSSF and XSSF.
      Specified by:
        `getCreationHelper` in interface `Workbook`

    - #### addToolPack

          public void addToolPack(UDFFinder toopack)

      Register a new toolpack in this workbook.
      Specified by:
        `addToolPack` in interface `Workbook`
      Parameters:
        `toopack` - the toolpack to register

    - #### setForceFormulaRecalculation

          public void setForceFormulaRecalculation(boolean value)

      Whether the application shall perform a full recalculation when the workbook is opened.

      Typically you want to force formula recalculation when you modify cell formulas or values of a workbook previously created by Excel. When set to true, this flag will tell Excel that it needs to recalculate all formulas in the workbook the next time the file is opened.

      Note, that recalculation updates cached formula results and, thus, modifies the workbook. Depending on the version, Excel may prompt you with "Do you want to save the changes in filename?" on close.

      Specified by:
        `setForceFormulaRecalculation` in interface `Workbook`
      Parameters:
        `value` - true if the application will perform a full recalculation of workbook values when the workbook is opened
      Since:
        3.8

    - #### getForceFormulaRecalculation

          public boolean getForceFormulaRecalculation()

      Whether Excel will be asked to recalculate all formulas when the workbook is opened.
      Specified by:
        `getForceFormulaRecalculation` in interface `Workbook`
      Since:
        3.8

    - #### changeExternalReference

          public boolean changeExternalReference(java.lang.String oldUrl,
                                                 java.lang.String newUrl)

      Changes an external referenced file to another file. A formula in Excel which references a cell in another file is saved in two parts: The referenced file is stored in an reference table. the row/cell information is saved separate. This method invocation will only change the reference in the lookup-table itself.
      Parameters:
        `oldUrl` - The old URL to search for and which is to be replaced
        `newUrl` - The URL replacement
      Returns:
        true if the oldUrl was found and replaced with newUrl. Otherwise false

    - #### getInternalWorkbook

          @Internal
          public InternalWorkbook getInternalWorkbook()

    - #### getSpreadsheetVersion

          public SpreadsheetVersion getSpreadsheetVersion()

      Returns the spreadsheet version (EXCLE97) of this workbook
      Specified by:
        `getSpreadsheetVersion` in interface `Workbook`
      Returns:
        EXCEL97 SpreadsheetVersion enum
      Since:
        3.14 beta 2

    - #### getEncryptionInfo

          public EncryptionInfo getEncryptionInfo()

      Overrides:
        `getEncryptionInfo` in class `POIDocument`
      Returns:
        the encryption info if the document is encrypted, otherwise `null`

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.